#.
# dispatcher.rb
#.
# Copyright 2014 by siberas, http://www.siberas.de
# This file is part of WATOBO (Web Application Tool Box) http://watobo.sourceforge.com
# WATOBO is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 2 of the License.
# WATOBO is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with WATOBO; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# @private
module Watobo#:nodoc: all
  module Plugin
    class CQ5
      class Dispatcher
        
        def stop
          @t_disp.kill unless @t_disp.nil?
        end
        
        def run
          @known_urls = []
          puts Watobo::Plugin::CQ5.ignore_patterns
          @t_disp = Thread.new{
            loop do
               new_item = @dqueue.deq
               unless @known_urls.include?( new_item[:url] )
                 @known_urls << new_item[:url]
                 if Watobo::Plugin::CQ5.ignore_patterns.empty?
                  # puts "* no ignore patterns defined"
                   @wqueue << new_item
                 elsif Watobo::Plugin::CQ5.ignore_patterns.select{|ip| new_item[:url] =~ /#{ip}/i }.empty?
                   @wqueue << new_item 
                 end
                 
                 @rqueue << new_item
               else
                 puts "[DUPLICATED] >> #{new_item[:url]}"
               end
              
             end
          }
        end
        
        def initialize(disp_queue, work_queue, result_queue)
          @dqueue = disp_queue
          @wqueue = work_queue
          @rqueue = result_queue
          @t_disp = nil
        end
      end
    end
  end
end